// Ponteiro Nulo: aquele que no indica nenhum endereo de memria

#include <iostream>
using namespace std;

int main(void) {
    int x = 10;
    int * p;
    int * q;
    int * r;

    p = &x;     // Aponta "p" para o endereo de X
    q = p;      // Faz "q" apontar para o endereo atual de "p"
    *q = 20;    // Modifica o valor do endereo apontado por "q"
    r = NULL;   // Indica que "r" no aponta para nenhum endereo
                // NULL  uma constante pr-definida no C/C++

   // Observe os valores impressos
    cout << " X vale: " << x << endl;
    cout << "*P vale: " << *p << endl;
    cout << "*Q vale: " << *q << endl;

    // Observe os endereos
    cout << "&X vale: " << &x << endl;
    cout << " P vale: " << p << endl;
    cout << " Q vale: " << q << endl;
    cout << " R vale: " << r << endl;

    // No tente imprimir o valor de um ponteiro nulo!
    //cout << "*R vale: " << *r << endl;

}

