// Ponteiro para Struct
#include <iostream>
using namespace std;

struct aluno {
    int matricula;
    float nota;
};

int main(void) {
    // Declara dois alunos "a" e "b"
    aluno a, b;
    // Declara um ponteiro para um aluno
    aluno *p;

    a.matricula = 12011410;
    a.nota = 7.5;

    p = &a;     // Aponta "p" para o endereo de "a"
    b = a;      // Copia "a" para "b"

    // NO esquea dos parnteses ao redor do (*p) !
    (*p).matricula = 13011410;  // Modifica matricula do aluno apontado por "p"
    (*p).nota = 9.5;            // Modifica nota do aluno apontado por "p"

   // Observe os valores impressos
    cout << "   a.matr vale: " << a.matricula << endl;
    cout << "   a.nota vale: " << a.nota << endl;
    cout << "   b.matr vale: " << b.matricula << endl;
    cout << "   b.nota vale: " << b.nota << endl;
    cout << "(*p).matr vale: " << (*p).matricula << endl;
    cout << "(*p).nota vale: " << (*p).nota << endl;

    // Observe os endereos
    cout << "&a: " << &a << endl;
    cout << "&b: " << &b << endl;
    cout << " p: " << p << endl;

}

